#include <exec/execbase.h>
#include <exec/memory.h>
#include <intuition/classusr.h>
#include <intuition/imageclass.h>
#include <intuition/gadgetclass.h>
#include <intuition/cghooks.h>
#include <intuition/icclass.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/asl.h>
#include <proto/timer.h>
#include <proto/gadtools.h>
#include <proto/graphics.h>
#include <proto/intuition.h>

#include <proto/hrg_all.h>

#define DITH_SIZE		16
#define PROTECTED		8
#define WIDTH_STEP	8
#define HEIGHT_STEP	8

#define GADGETID(msg) (((struct Gadget *)((msg).IAddress))->GadgetID)
#define SHIFT_KEY(q) (((q) & IEQUALIFIER_LSHIFT) || ((q) & IEQUALIFIER_RSHIFT))

#define MERLIN_KEY 0x40001000

#define SETTAG(tag,value) {tags[cnt].ti_Tag = tag; tags[cnt].ti_Data = (ULONG)value; cnt++;}

#define BUF_LENGTH	65536
#define MIN_WIDTH		98
#define MIN_HEIGHT	(54 + top)

#define ENVNAME "MerlinFLI.prefs"

#ifndef min
#define min(a, b) ((a) < (b) ? (a) : (b))
#endif
#ifndef max
#define max(a, b) ((a) > (b) ? (a) : (b))
#endif

enum {
    KEY_UP = 76,
    KEY_DOWN,
    KEY_RIGHT,
    KEY_LEFT,
    KEY_PLUS = 0x1b,
    KEY_MINUS = 0x3a,
    KEY_SPACE = 0x40,
    KEY_c = 0x33,
    KEY_q = 0x10
};

enum {
    NO_ERR = 1,
    MEM_ERR,
    GFX_ERR,
    INT_ERR,
    SYS_ERR,
    REN_ERR,
    DBL_ERR,
    SCR_ERR,
    REQ_ERR,
    WIN_ERR,
    FND_ERR,
    PIP_ERR,
    DRI_ERR,
    PAR_ERR,
    MPG_ERR,
    RNG_ERR,
    GET_ERR,
    BRK_ERR,
    GAD_ERR,
    VIS_ERR,
    MEN_ERR,
    TIM_ERR,
};

enum {
    UP_ID = 1,
    DOWN_ID,
    LEFT_ID,
    RIGHT_ID,
    HORIZ_ID,
    VERT_ID,
    NO_GADGET
};
